<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="课程" prop="courseId">
        <el-select filterable  v-model="queryParams.courseId" placeholder="请选择课程"  clearable size="small" @change="courseChange(queryParams.courseId)">
          <el-option
            v-for="dict in courseLists"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="小节" prop="videoId">
        <el-select filterable  v-model="queryParams.videoId" placeholder="请选择小节"  clearable size="small">
          <el-option
            v-for="dict in videoList"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="企微昵称" prop="nickName">
        <el-input
          v-model="queryParams.nickName"
          placeholder="请输入企微昵称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker v-model="createTime" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" @change="change"></el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['qw:user:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="courseWatchLogList" @selection-change="handleSelectionChange"  show-summary :summary-method="getSummaries" >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="企微员工名称" align="center" prop="qwUserName" />
      <el-table-column label="发课时间" align="center" prop="createTime"/>
      <el-table-column label="课程名称" align="center" prop="courseName" />
      <el-table-column label="小节名称" align="center" prop="videoName" />
      <el-table-column label="待看课" align="center" prop="type3" />
      <el-table-column label="看课中" align="center" prop="type1" />
      <el-table-column label="已完课" align="center" prop="type2" />
      <el-table-column label="看课中断" align="center" prop="type4" />
      <el-table-column label="发课数" align="center" prop="sendNumber" />
      <el-table-column label="注册用户待看课数" align="center" prop="isUserWaitNumber" />
      <el-table-column label="未注册用户待看课数" align="center" prop="noUserWaitNumber" />
      <el-table-column label="上线率" align="center" prop="onLineRate" />
      <el-table-column label="完课率" align="center" prop="finishedRate" />
      <el-table-column label="消耗红包金额" align="center" prop="redAmount" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import { listCourseWatchLog, getCourseWatchLog, delCourseWatchLog, addCourseWatchLog, updateCourseWatchLog, exportCourseWatchLog,statisticsList,statisticsExport } from "@/api/course/qw/courseWatchLog";
import { courseList,videoList } from '@/api/course/courseRedPacketLog'
import { getDateRange } from '@/utils/common'
export default {
  name: "CourseWatchLog",
  data() {
    return {
      activeName:"00",
      createTime:null,
      courseLists:[],
      videoList:[],
      logTypeOptions:[],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 短链课程看课记录表格数据
      courseWatchLogList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        nickName: null,
        videoId: null,
        logType: null,
        qwExternalContactId: null,
        duration: null,
        qwUserId: null,
        companyUserId: null,
        companyId: null,
        courseId: null,
        sTime:null,
        eTime:null,
        scheduleStartTime: null,
        scheduleEndTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      scheduleTime: null,
    };
  },
  created() {
    // // 设置默认时间范围为最近7天
    // this.createTime = getDateRange(7);
    // // 设置查询参数的时间
    // this.queryParams.sTime = this.createTime[0];
    // this.queryParams.eTime = this.createTime[1];

    courseList().then(response => {
      this.courseLists = response.list;
    });
    this.getList();
    this.getDicts("sys_course_watch_log_type").then(response => {
      this.logTypeOptions = response.data;
    });
  },
  methods: {
     getSummaries(param) {
      let totalNum = 0;
      const { columns, data } = param;
      const sums = [];
      let totalOnline = 0;
      let totalFinishCourse = 0;
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = "总计";
          return;
        }
        const values = data.map((item) => Number(item[column.property]));
        if (!values.every((value) => isNaN(value))) {
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          if(index > 3 && totalNum != 0){
              sums[index] = sums[index] + "("+ ((sums[index] / totalNum) * 100).toFixed(2)  + "%)"
          }
          if( column.property=="videoName"){
            sums[index] = "";
          }
          if (
            column.property === "type3" ||
            column.property === "type1" ||
            column.property === "type2" ||
            column.property === "type4" ||
            column.property === "sendNumber" ||
            column.property === "isUserWaitNumber" ||
            column.property === "noUserWaitNumber" ||
            column.property === "onLineRate" ||
            column.property === "finishedRate" ||
            column.property === "redAmount" 
          ) {
          }
        } else {
          sums[index] = "";
          if(index === 12 || index === 13){
            //  let numbers = data.map(item => {
            //   return parseFloat(item[column.property].replace('%', '')) || 0; // 处理空值或无效值
            // });
            // let sumRates = numbers.reduce((acc, curr) => acc + curr, 0);
            // console.log("index:" + index + " rates：" + sumRates + " data.length:" + data.length);
            if(index === 12 && !!sums[9]){
              let sumsNum = sums[6] + sums[7] + sums[8];
              sums[index] = (sumsNum * 100 / sums[9]).toFixed(2) + '%';
            } else if(index === 13 && !!sums[9]){
              sums[index] =  (sums[7] * 100 / sums[9]).toFixed(2) + '%';
            }
          } 
        }
      });
      console.log(sums);
      return sums;
    },
    courseChange(row){
      this.queryParams.videoId=null;
      if(row === ''){
        this.videoList=[];
        return
      }
      videoList(row).then(response => {
        this.videoList=response.list
      });
    },
    change() {
      if (this.createTime != null) {
        this.queryParams.sTime = this.createTime[0];
        this.queryParams.eTime = this.createTime[1];
      } else {
        this.queryParams.sTime = null;
        this.queryParams.eTime = null;
      }
    },
    handleClickX(tab,event){
      this.activeName=tab.name;
      if(tab.name=="00"){
        this.queryParams.logType=null;
      }else{
        this.queryParams.logType=tab.name;
      }
      this.getList()
    },
    /** 查询短链课程看课记录列表 */
    getList() {
      this.loading = true;
      statisticsList(this.queryParams).then(response => {
        this.courseWatchLogList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        logId: null,
        userId: null,
        videoId: null,
        logType: null,
        createTime: null,
        updateTime: null,
        qwExternalContactId: null,
        duration: null,
        qwUserId: null,
        companyUserId: null,
        companyId: null,
        courseId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      if (!this.queryParams.sTime || !this.queryParams.eTime) {
        this.$message.warning("请选择创建时间");
        return;
      }
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.createTime = null;
      this.scheduleTime = null;
      this.queryParams.sTime = null;
      this.queryParams.eTime = null;
      this.queryParams.scheduleStartTime = null;
      this.queryParams.scheduleEndTime = null;
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.logId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加短链课程看课记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const logId = row.logId || this.ids
      getCourseWatchLog(logId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改短链课程看课记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.logId != null) {
            updateCourseWatchLog(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCourseWatchLog(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const logIds = row.logId || this.ids;
      this.$confirm('是否确认删除短链课程看课记录编号为"' + logIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCourseWatchLog(logIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 检查是否选择了时间范围
      if (!this.queryParams.sTime || !this.queryParams.eTime) {
        this.$message.warning("请选择创建时间后才能导出");
        return;
      }
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有企微看课记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return statisticsExport(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    handleScheduleTimeChange(val) {
      if (val) {
        this.queryParams.scheduleStartTime = val[0];
        this.queryParams.scheduleEndTime = val[1];
      } else {
        this.queryParams.scheduleStartTime = null;
        this.queryParams.scheduleEndTime = null;
      }
    },
  }
};
</script>
